package server

import (
	"contract_backend/config"
	"contract_backend/dao"

	"github.com/gin-contrib/cors"
	"github.com/gin-gonic/gin"
	log "github.com/sirupsen/logrus"
)

var conf *config.Config
var d *dao.Dao

func StartServer(_conf *config.Config, _da *dao.Dao) {
	conf = _conf
	d = _da
	if !conf.Debug {
		gin.SetMode(gin.ReleaseMode)
	}
	engine := gin.Default()

	_cors := cors.DefaultConfig()
	_cors.AllowAllOrigins = true
	_cors.AllowHeaders = []string{"*"}

	engine.Use(cors.New(_cors))

	initRouter(engine)
	log.Infof("start http server listening %s", conf.Server.Listen)
	if err := engine.Run(conf.Server.Listen); err != nil {
		log.Error("http server run error: ", err)
	}
}

func withSuccess(obj interface{}) interface{} {
	return gin.H{
		"code": 0,
		"msg":  "ok",
		"data": obj,
	}
}

func withError(msg string) interface{} {
	return gin.H{
		"code":  1,
		"error": msg,
		"data":  "",
	}
}
